#include "DLL.CH"
#include "FILEIO.CH"
#include "COMMON.CH"

#define FORMAT_MESSAGE_FROM_SYSTEM    0x00001000
DLLFUNCTION FormatMessageA( nFlags, @cPSource, nMessage, nLanguage, @cBuffer, nSize, xArray ) USING STDCALL FROM KERNEL32.DLL

DLLFUNCTION GetLastError() USING STDCALL FROM KERNEL32.DLL

FUNCTION MAIN(cFile, cTime)
LOCAL aTime := {}
LOCAL cDate

CLS

   IF PCOUNT() > 0
      SET EPOCH TO YEAR( DATE() ) - 50
      SET CENTURY ON
      SET DATE TO SYSTEM

      cDate := FileTime( DATE(), ConvUTC( TIME() ) )

      AADD( aTime, cDate )
      AADD( aTime, cDate )
      AADD( aTime, cDate )

      SetFileTime(cFile, aTime)
   ELSE
      ALERT("Filename fehlt")
   ENDIF
RETURN NIL

FUNCTION SetFileTime(cFile, aTime)
LOCAL cCreation
LOCAL cAccess
LOCAL cWrite
LOCAL nKernel32Dll
LOCAL nH
LOCAL nPt := 0

   IF PCOUNT() = 2
      cCreation := aTime[1]
      cAccess   := aTime[2]
      cWrite    := aTime[3]
      nKernel32Dll:=DllLoad("Kernel32.dll")
      nH := FOPEN(cFile, FO_WRITE+FO_SHARED )
      If nKernel32Dll > 0 .AND. nH # -1
         nPt := DllCall(nKernel32Dll, DLL_STDCALL, 'SetFileTime', nH, @cCreation, @cAccess, @cWrite)
         DllUnload(nKernel32Dll)
      EndIf

      IF nH # -1
         FCLOSE(nH)
      ENDIF
   ENDIF

   IF nPt = 0
      ALERT( FormatErrorMessage( nPt ) )
   ENDIF

RETURN NIL

FUNCTION FileTime(dDate, cTime)
LOCAL cConvertTime, cFileTime:=Space(8)

  IF dDate==NIL .AND. cTime==NIL
    DllCall("Kernel32.dll",DLL_STDCALL,"GetSystemTimeAsFileTime", @cFileTime)
    RETURN cFileTime
  ENDIF

  dDate:=IF(dDate=NIL,Date(),dDate)
  cTime:=IF(cTime=NIL,Time(),cTime)

  cConvertTime:=w2Bin(Year(dDate))+w2Bin(Month(dDate))+w2Bin(0)+w2Bin(Day(dDate))+w2Bin(THours(cTime))+w2Bin(TMins(cTime))+w2Bin(TSecs(cTime))+w2Bin(0)
  IF DllCall("Kernel32.dll",DLL_STDCALL,"SystemTimeToFileTime", cConvertTime, @cFileTime)==0
    RETURN Space(8)
  ENDIF

RETURN cFileTime

FUNCTION THours(cTime)
  DEFAULT cTime TO Time()
RETURN Val(SubStr(cTime,1,2))

FUNCTION TMins(cTime)
  DEFAULT cTime TO Time()
RETURN Val(SubStr(cTime,4,2))

FUNCTION TSecs(cTime)
  DEFAULT cTime TO Time()
RETURN Val(SubStr(cTime,7,2))

FUNCTION FormatErrorMessage( nPt )
   LOCAL cMessage := SPACE(512)

   DEFAULT nPt TO GetLastError()

   FormatMessageA( FORMAT_MESSAGE_FROM_SYSTEM,;
                     0,;
                     nPt,;
                     0,;
                     @cMessage,;
                     512,;
                     0 )

   cMessage := LTRIM(STR(nPt)) + " = " + cMessage

RETURN cMessage

FUNCTION Sec2HMS( nSec )
LOCAL cHHMMSS := ""
LOCAL nInt    := 0
LOCAL nHH     := 0
LOCAL nMM     := 0
LOCAL nSS     := 0

   IF nSec >= 3600
      nHH := INT( nSec / 60 / 60 )
      nInt := ( nSec - ( nHH * 60 * 60 ) ) / 60
   ELSE
      nInt := nSec / 60
   ENDIF

   nMM := INT( nInt )
   nSS := INT( ( nInt - nMM ) * 60 )

   cHHMMSS := IF( nHH > 0, STRZERO( nHH, 2 ) + ":", "00:" ) + ;
                  IF( nMM > 0, STRZERO( nMM, 2 ) + ":", "00:" ) + ;
                  STRZERO( nSS, 2 )

RETURN cHHMMSS

FUNCTION HMS2Sec( cHHMMSS )
LOCAL nSec := 0
LOCAL nHH  := 0
LOCAL nMM  := 0
LOCAL nSS  := 0

   nHH := VAL( SUBSTR( cHHMMSS, 1, 2 ) ) * 60 * 60
   nMM := VAL( SUBSTR( cHHMMSS, 4, 5 ) ) * 60
   nSS := VAL( SUBSTR( cHHMMSS, 7, 8 ) )

   nSec = nHH + nMM + nSS

RETURN nSec

FUNCTION ConvUTC( cTIME )
LOCAL cRet := "00:00:00"
LOCAL nSec := HMS2Sec( cTIME )

   cRet := SEC2HMS(nSec-(60*60)) // - 1 Stunde

RETURN cRet
*
*
*